/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var B=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(F){for(var e=[],A=0,S=F.length;A<S;A++)e[A]=B[F[A]];return e};define(B[21],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class A{static get(){const v=new Map,T=new Map,r=new Map,l=new Map;function t(o,n){o.has(n.detail)||o.set(n.detail,-n.timestamp)}function a(o,n){const i=o.get(n.detail);i&&(i>=0||o.set(n.detail,i+n.timestamp))}let h=[];typeof F=="function"&&typeof F.getStats=="function"&&(h=F.getStats().slice(0).sort((o,n)=>o.timestamp-n.timestamp));for(const o of h)switch(o.type){case 10:t(v,o);break;case 11:case 12:a(v,o);break;case 21:t(T,o);break;case 22:a(T,o);break;case 33:t(r,o);break;case 34:a(r,o);break;case 31:t(l,o);break;case 32:a(l,o);break}let c=0;r.forEach(o=>c+=o);function d(o){const n=[];return o.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:d(v),amdInvoke:d(T),nodeRequire:d(r),nodeEval:d(l),nodeRequireTotal:c}}static toMarkdownTable(v,T){let r="";const l=[];return v.forEach((t,a)=>{l[a]=t.length}),T.forEach(t=>{t.forEach((a,h)=>{typeof a>"u"&&(a=t[h]="-");const c=a.toString().length;l[h]=Math.max(c,l[h])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(l[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(l[a])} `}),r+=`|
`,T.forEach(t=>{t.forEach((a,h)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(l[h]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=A}),define(B[4],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xb=e.$Wb=e.$Vb=void 0;let A;function S(i){A=i}e.$Vb=S;function v(){return A}e.$Wb=v;class T{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([l(o("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[l(" "),a(h(s.oldValue,70),{color:"red",strikeThrough:!0}),l(" "),a(h(s.newValue,60),{color:"green"})]:[l(" (unchanged)")]:[l(" "),a(h(s.newValue,60),{color:"green"}),l(" (initial)")]}handleObservableChanged(s,f){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(f)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const f=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),f.apply(s,[w,N]))}handleDerivedRecomputed(s,f){const w=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(f),this.formatChanges(w),{data:[{fn:s._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(s,f){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(f),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const f=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),f.apply(s,[w,N]))}handleAutorunTriggered(s){const f=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:s._runFn}]}])),f.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let f=s.getDebugName();f===void 0&&(f=""),console.log(...this.b([t("transaction"),a(f,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Xb=T;function r(i){const s=new Array,f=[];let w="";function N(k){if("length"in k)for(const g of k)g&&N(g);else"text"in k?(w+=`%c${k.text}`,s.push(k.style),k.data&&f.push(...k.data)):"data"in k&&f.push(...k.data)}N(i);const P=[w,...s];return P.push(...f),P}function l(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function f(N){return Object.entries(N).reduce((P,[k,g])=>`${P}${k}:${g};`,"")}const w={color:s.color};return s.strikeThrough&&(w["text-decoration"]="line-through"),s.bold&&(w["font-weight"]="bold"),{text:i,style:f(w)}}function h(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?c(i,s):d(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function c(i,s){let f="[ ",w=!0;for(const N of i){if(w||(f+=", "),f.length-5>s){f+="...";break}w=!1,f+=`${h(N,s-f.length)}`}return f+=" ]",f}function d(i,s){let f="{ ",w=!0;for(const[N,P]of Object.entries(i)){if(w||(f+=", "),f.length-5>s){f+="...";break}w=!1,f+=`${N}: ${h(P,s-f.length)}`}return f+=" }",f}function o(i,s){let f="";for(let w=1;w<=s;w++)f+=i;return f}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(B[5],K([0,1,4]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=void 0;let S;function v(s){S=s}e.$4b=v;class T{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f){return S({debugName:()=>{const w=c(f);if(w!==void 0)return w;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(f.toString());return P?`${this.debugName}.${P[2]}`:`${this.debugName} (mapped)`}},w=>f(this.read(w),w))}}e.$5b=T;class r extends T{constructor(){super(...arguments),this.c=new Set}addObserver(f){const w=this.c.size;this.c.add(f),w===0&&this.f()}removeObserver(f){this.c.delete(f)&&this.c.size===0&&this.g()}f(){}g(){}}e.$6b=r;function l(s,f){const w=new a(s,f);try{s(w)}finally{w.finish()}}e.$7b=l;function t(s,f,w){s?f(s):l(f,w)}e.$8b=t;class a{constructor(f,w){this._fn=f,this.b=w,this.a=[],(0,A.$Wb)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():c(this._fn)}updateObserver(f,w){this.a.push({observer:f,observable:w}),f.beginUpdate(w)}finish(){const f=this.a;this.a=null;for(const{observer:w,observable:N}of f)w.endUpdate(N);(0,A.$Wb)()?.handleEndTransaction()}}e.$9b=a;function h(s,f,w,N){let P;if(s!==void 0)if(typeof s=="function"){if(P=s(),P!==void 0)return P}else return s;if(f!==void 0&&(P=c(f),P!==void 0))return P;if(w!==void 0){for(const k in w)if(w[k]===N)return k}}e.$0b=h;function c(s){const f=s.toString(),N=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(N?N[1]:void 0)?.trim()}e.$$b=c;function d(s,f){return typeof s=="string"?new o(void 0,s,f):new o(s,void 0,f)}e.$_b=d;class o extends r{get debugName(){return h(this.d,void 0,this.b,this)??"ObservableValue"}constructor(f,w,N){super(),this.b=f,this.d=w,this.a=N}get(){return this.a}set(f,w,N){if(this.a===f)return;let P;w||(w=P=new a(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.a;this.e(f),(0,A.$Wb)()?.handleObservableChanged(this,{oldValue:k,newValue:f,change:N,didChange:!0,hadValue:!0});for(const g of this.c)w.updateObserver(g,this),g.handleChange(this,N)}finally{P&&P.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(f){this.a=f}}e.$ac=o;function n(s,f){return typeof s=="string"?new i(void 0,s,f):new i(s,void 0,f)}e.$bc=n;class i extends o{e(f){this.a!==f&&(this.a&&this.a.dispose(),this.a=f)}dispose(){this.a?.dispose()}}e.$cc=i}),define(B[9],K([0,1,42,2,5,4]),function(F,e,A,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=void 0;function r(n,i){return new d(n.debugName,i,void 0,void 0)}e.$Bb=r;function l(n){return new d(void 0,n,void 0,void 0)}e.$Cb=l;function t(n,i){return new d(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$Db=t;function a(n,i){const s=new S.$lb,f=t({debugName:n.debugName??(()=>(0,v.$$b)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(w,N)=>{s.clear(),i(w,N,s)});return(0,S.$kb)(()=>{f.dispose(),s.dispose()})}e.$Eb=a;function h(n){const i=new S.$lb,s=r({debugName:()=>(0,v.$$b)(n)||"(anonymous)"},f=>{i.clear(),n(f,i)});return(0,S.$kb)(()=>{s.dispose(),i.dispose()})}e.$Fb=h;var c;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(c||(c={}));class d{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$$b)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,f,w){this.h=i,this._runFn=s,this.i=f,this.j=w,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,T.$Wb)()?.handleAutorunCreated(this),this.k(),(0,S.$db)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,S.$eb)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,T.$Wb)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,T.$Wb)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,A.$zb)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:w=>w===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$Gb=d,function(n){n.Observer=d}(l||(e.$Cb=l={}));function o(n,i){let s;return r({debugName:()=>(0,v.$$b)(i)},f=>{const w=n.read(f),N=s;s=w,i({lastValue:N,newValue:w})})}e.$Hb=o}),define(B[10],K([0,1,6,2,5,4]),function(F,e,A,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=void 0;const r=(o,n)=>o===n;function l(o,n){return n!==void 0?new d(o,void 0,n,void 0,void 0,void 0,r):new d(void 0,void 0,o,void 0,void 0,void 0,r)}e.$Yb=l;function t(o,n){return new d(o.owner,o.debugName,n,void 0,void 0,void 0,o.equalityComparer??r)}e.$Zb=t;function a(o,n){return new d(o.owner,o.debugName,n,o.createEmptyChangeSummary,o.handleChange,void 0,o.equalityComparer??r)}e.$1b=a;function h(o,n){let i,s;n===void 0?(i=o,s=void 0):(s=o,i=n);const f=new S.$lb;return new d(s,()=>(0,v.$$b)(i)??"(anonymous)",w=>(f.clear(),i(w,f)),void 0,void 0,()=>f.dispose(),r)}e.$2b=h,(0,v.$4b)(l);var c;(function(o){o[o.initial=0]="initial",o[o.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",o[o.stale=2]="stale",o[o.upToDate=3]="upToDate"})(c||(c={}));class d extends v.$6b{get debugName(){return(0,v.$0b)(this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,s,f,w,N=void 0,P){super(),this.m=n,this.n=i,this._computeFn=s,this.p=f,this.q=w,this.s=N,this.t=P,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,T.$Wb)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const f=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,f)}finally{for(const N of this.k)N.removeObserver(this);this.k.clear()}const w=i&&!this.t(s,this.h);if((0,T.$Wb)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:w,hadValue:i}),w)for(const N of this.c)N.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new A.$ab}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.q?this.q({changedObservable:n,change:i,didChange:w=>w===n},this.l):!0,f=this.e===3;if(s&&(this.e===1||f)&&(this.e=2,f))for(const w of this.c)w.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$3b=d}),define(B[22],K([0,1,2,9,5,10,4]),function(F,e,A,S,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=void 0;function l(m){return new t(m)}e.$Ib=l;class t extends v.$5b{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function a(m){const O=(0,v.$_b)("promiseValue",{});return m.then(D=>{O.set({value:D},void 0)}),O}e.$Jb=a;function h(m,O){return new Promise(D=>{let b=!1,C=!1;const j=(0,S.$Cb)(z=>{const I=m.read(z);O(I)&&(b?j.dispose():C=!0,D(I))});b=!0,C&&j.dispose()})}e.$Kb=h;function c(m,O){return new d(m,O)}e.$Lb=c;class d extends v.$6b{constructor(O,D){super(),this.h=O,this._getValue=D,this.b=!1,this.k=b=>{const C=this._getValue(b),j=!this.b||this.a!==C;(0,r.$Wb)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:C,change:void 0,didChange:j,hadValue:this.b}),j&&(this.a=C,this.b&&(0,v.$7b)(z=>{for(const I of this.c)z.updateObserver(I,this),I.handleChange(this,void 0)},()=>{const z=this.i();return"Event fired"+(z?`: ${z}`:"")}),this.b=!0)}}i(){return(0,v.$$b)(this._getValue)}get debugName(){const O=this.i();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$Mb=d,function(m){m.Observer=d}(c||(e.$Lb=c={}));function o(m,O){return new n(m,O)}e.$Nb=o;class n extends v.$6b{constructor(O,D){super(),this.debugName=O,this.b=D,this.h=()=>{(0,v.$7b)(b=>{for(const C of this.c)b.updateObserver(C,this),C.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return typeof m=="string"?new s(m):new s(void 0,m)}e.$Ob=i;class s extends v.$6b{get debugName(){return(0,v.$0b)(this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,D){super(),this.a=O,this.b=D}trigger(O,D){if(!O){(0,v.$7b)(b=>{this.trigger(b,D)},()=>`Trigger signal ${this.debugName}`);return}for(const b of this.c)O.updateObserver(b,this),b.handleChange(this,D)}get(){}}function f(m,O,D){const b=(0,v.$_b)("debounced",void 0);let C;return D.add((0,S.$Cb)(j=>{const z=m.read(j);C&&clearTimeout(C),C=setTimeout(()=>{(0,v.$7b)(I=>{b.set(z,I)})},O)})),b}e.$Pb=f;function w(m,O,D){const b=(0,v.$_b)("triggeredRecently",!1);let C;return D.add(m(()=>{b.set(!0,void 0),C&&clearTimeout(C),C=setTimeout(()=>{b.set(!1,void 0)},O)})),b}e.$Qb=w;function N(m){const O=new k(!1);return m.addObserver(O),(0,A.$kb)(()=>{m.removeObserver(O)})}e.$Rb=N;function P(m){const O=new k(!0);return m.addObserver(O),m.reportChanges(),(0,A.$kb)(()=>{m.removeObserver(O)})}e.$Sb=P;class k{constructor(O){this.b=O,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&O.reportChanges()}handlePossibleChange(O){}handleChange(O,D){}}function g(m){let O;return(0,T.$Yb)(b=>(O=m(b,O),O))}e.$Tb=g;function y(m,O){let D;const b=(0,v.$_b)("derivedObservableWithWritableCache.counter",0),C=(0,T.$Yb)(m,j=>(b.read(j),D=O(j,D),D));return Object.assign(C,{clearCache:j=>{D=void 0,b.set(b.get()+1,j)}})}e.$Ub=y}),define(B[11],K([0,1,5,10,9,22,4]),function(F,e,A,S,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return A.$_b}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return A.$bc}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return A.$7b}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return A.$8b}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$Yb}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$Zb}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$1b}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$2b}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$Cb}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$Hb}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$Db}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$Fb}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$Bb}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$Eb}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return T.$Ib}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return T.$Pb}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return T.$Tb}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return T.$Ub}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return T.$Rb}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return T.$Sb}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return T.$Lb}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return T.$Jb}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return T.$Ob}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return T.$Nb}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return T.$Kb}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return T.$Qb}}),!1&&(0,r.$Vb)(new r.$Xb)}),define(B[23],K([0,1,6,2]),function(F,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function v(P){const k=P;return k?typeof k.read=="function":!1}e.$sc=v;function T(P){const k=P;return k?[k.on,k.pause,k.resume,k.destroy].every(g=>typeof g=="function"):!1}e.$tc=T;function r(P){const k=P;return k?T(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$uc=r;function l(P,k){return new t(P,k)}e.$vc=l;class t{constructor(k,g){this.e=k,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(g=>g(k))}h(k){this.c.error.length===0?(0,A.$Y)(k):this.c.error.slice(0).forEach(g=>g(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,g){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(k,g){if(this.a.destroyed)return;let y;switch(k){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const m=y.indexOf(g);m>=0&&y.splice(m,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(P,k){const g=[];let y;for(;(y=P.read())!==null;)g.push(y);return k(g)}e.$wc=a;function h(P,k,g){const y=[];let m;for(;(m=P.read())!==null&&y.length<g;)y.push(m);return m===null&&y.length>0?k(y):{read:()=>{if(y.length>0)return y.shift();if(typeof m<"u"){const O=m;return m=void 0,O}return P.read()}}}e.$xc=h;function c(P,k){return new Promise((g,y)=>{const m=[];d(P,{onData:O=>{k&&m.push(O)},onError:O=>{k?y(O):g(void 0)},onEnd:()=>{g(k?k(m):void 0)}})})}e.$yc=c;function d(P,k,g){P.on("error",y=>{g?.isCancellationRequested||k.onError(y)}),P.on("end",()=>{g?.isCancellationRequested||k.onEnd()}),P.on("data",y=>{g?.isCancellationRequested||k.onData(y)})}e.$zc=d;function o(P,k){return new Promise((g,y)=>{const m=new S.$lb,O=[],D=j=>{if(O.push(j),O.length>k)return m.dispose(),P.pause(),g({stream:P,buffer:O,ended:!1})},b=j=>y(j),C=()=>g({stream:P,buffer:O,ended:!0});m.add((0,S.$kb)(()=>P.removeListener("error",b))),P.on("error",b),m.add((0,S.$kb)(()=>P.removeListener("end",C))),P.on("end",C),m.add((0,S.$kb)(()=>P.removeListener("data",D))),P.on("data",D)})}e.$Ac=o;function n(P,k){const g=l(k);return g.end(P),g}e.$Bc=n;function i(){const P=l(()=>{throw new Error("not supported")});return P.end(),P}e.$Cc=i;function s(P){let k=!1;return{read:()=>k?null:(k=!0,P)}}e.$Dc=s;function f(P,k,g){const y=l(g);return d(P,{onData:m=>y.write(k.data(m)),onError:m=>y.error(k.error?k.error(m):m),onEnd:()=>y.end()}),y}e.$Ec=f;function w(P,k,g){let y=!1;return{read:()=>{const m=k.read();return y?m:(y=!0,m!==null?g([P,m]):P)}}}e.$Fc=w;function N(P,k,g){let y=!1;const m=l(g);return d(k,{onData:O=>y?m.write(O):(y=!0,m.write(g([P,O]))),onError:O=>m.error(O),onEnd:()=>{y||(y=!0,m.write(P)),m.end()}}),m}e.$Gc=N}),define(B[12],K([0,1,43,23]),function(F,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const v=typeof Buffer<"u",T=new A.$T(()=>new Uint8Array(256));let r,l;class t{static alloc($){return v?new t(Buffer.allocUnsafe($)):new t(new Uint8Array($))}static wrap($){return v&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new t($)}static fromString($,U){return!(U?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from($)):(r||(r=new TextEncoder),new t(r.encode($)))}static fromByteArray($){const U=t.alloc($.length);for(let V=0,G=$.length;V<G;V++)U.buffer[V]=$[V];return U}static concat($,U){if(typeof U>"u"){U=0;for(let _=0,H=$.length;_<H;_++)U+=$[_].byteLength}const V=t.alloc(U);let G=0;for(let _=0,H=$.length;_<H;_++){const W=$[_];V.set(W,G),G+=W.byteLength}return V}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=t.alloc(this.byteLength);return $.set(this),$}toString(){return v?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice($,U){return new t(this.buffer.subarray($,U))}set($,U){if($ instanceof t)this.buffer.set($.buffer,U);else if($ instanceof Uint8Array)this.buffer.set($,U);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),U);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return d(this.buffer,$)}writeUInt32BE($,U){o(this.buffer,$,U)}readUInt32LE($){return n(this.buffer,$)}writeUInt32LE($,U){i(this.buffer,$,U)}readUInt8($){return s(this.buffer,$)}writeUInt8($,U){f(this.buffer,$,U)}indexOf($,U=0){return a(this.buffer,$ instanceof t?$.buffer:$,U)}}e.$Hc=t;function a(I,$,U=0){const V=$.byteLength,G=I.byteLength;if(V===0)return 0;if(V===1)return I.indexOf($[0]);if(V>G-U)return-1;const _=T.value;_.fill($.length);for(let Q=0;Q<$.length;Q++)_[$[Q]]=$.length-Q-1;let H=U+$.length-1,W=H,p=-1;for(;H<G;)if(I[H]===$[W]){if(W===0){p=H;break}H--,W--}else H+=Math.max($.length-W,_[I[H]]),W=$.length-1;return p}e.$Ic=a;function h(I,$){return I[$+0]<<0>>>0|I[$+1]<<8>>>0}e.$Jc=h;function c(I,$,U){I[U+0]=$&255,$=$>>>8,I[U+1]=$&255}e.$Kc=c;function d(I,$){return I[$]*2**24+I[$+1]*2**16+I[$+2]*2**8+I[$+3]}e.$Lc=d;function o(I,$,U){I[U+3]=$,$=$>>>8,I[U+2]=$,$=$>>>8,I[U+1]=$,$=$>>>8,I[U]=$}e.$Mc=o;function n(I,$){return I[$+0]<<0>>>0|I[$+1]<<8>>>0|I[$+2]<<16>>>0|I[$+3]<<24>>>0}e.$Nc=n;function i(I,$,U){I[U+0]=$&255,$=$>>>8,I[U+1]=$&255,$=$>>>8,I[U+2]=$&255,$=$>>>8,I[U+3]=$&255}e.$Oc=i;function s(I,$){return I[$]}e.$Pc=s;function f(I,$,U){I[U]=$}e.$Qc=f;function w(I){return S.$wc(I,$=>t.concat($))}e.$Rc=w;function N(I){return S.$Dc(I)}e.$Sc=N;function P(I){return S.$yc(I,$=>t.concat($))}e.$Tc=P;async function k(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await P(I.stream)])}e.$Uc=k;function g(I){return S.$Bc(I,$=>t.concat($))}e.$Vc=g;function y(I){return S.$Ec(I,{data:$=>typeof $=="string"?t.fromString($):t.wrap($)},$=>t.concat($))}e.$Wc=y;function m(I){return S.$vc($=>t.concat($),I)}e.$Xc=m;function O(I,$){return S.$Fc(I,$,U=>t.concat(U))}e.$Yc=O;function D(I,$){return S.$Gc(I,$,U=>t.concat(U))}e.$Zc=D;function b(I){let $=0,U=0,V=0;const G=new Uint8Array(Math.floor(I.length/4*3)),_=W=>{switch(U){case 3:G[V++]=$|W,U=0;break;case 2:G[V++]=$|W>>>2,$=W<<6,U=3;break;case 1:G[V++]=$|W>>>4,$=W<<4,U=2;break;default:$=W<<2,U=1}};for(let W=0;W<I.length;W++){const p=I.charCodeAt(W);if(p>=65&&p<=90)_(p-65);else if(p>=97&&p<=122)_(p-97+26);else if(p>=48&&p<=57)_(p-48+52);else if(p===43||p===45)_(62);else if(p===47||p===95)_(63);else{if(p===61)break;throw new SyntaxError(`Unexpected base64 character ${I[W]}`)}}const H=V;for(;U>0;)_(0);return t.wrap(G).slice(0,H)}e.$1c=b;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:I},$=!0,U=!1){const V=U?j:C;let G="";const _=I.byteLength%3;let H=0;for(;H<I.byteLength-_;H+=3){const W=I[H+0],p=I[H+1],Q=I[H+2];G+=V[W>>>2],G+=V[(W<<4|p>>>4)&63],G+=V[(p<<2|Q>>>6)&63],G+=V[Q&63]}if(_===1){const W=I[H+0];G+=V[W>>>2],G+=V[W<<4&63],$&&(G+="==")}else if(_===2){const W=I[H+0],p=I[H+1];G+=V[W>>>2],G+=V[(W<<4|p>>>4)&63],G+=V[p<<2&63],$&&(G+="=")}return G}e.$2c=z}),define(B[24],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=void 0,e.$ec=Symbol("MicrotaskDelay")}),define(B[13],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.StringEOL=void 0;var A;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(A||(e.StringEOL=A={}));function S(v){let T=0,r=0,l=0,t=0;for(let a=0,h=v.length;a<h;a++){const c=v.charCodeAt(a);c===13?(T===0&&(r=a),T++,a+1<h&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,l=a+1):c===10&&(t|=1,T===0&&(r=a),T++,l=a+1)}return T===0&&(r=v.length),[T,r,v.length-l,t]}e.$Ts=S}),define(B[14],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(A||(e.LanguageId=A={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var T;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class l{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let c="mtk"+this.getForeground(a);const d=this.getFontStyle(a);return d&1&&(c+=" mtki"),d&2&&(c+=" mtkb"),d&4&&(c+=" mtku"),d&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(a,h){const c=this.getForeground(a),d=this.getFontStyle(a);let o=`color: ${h[c]};`;d&1&&(o+="font-style: italic;"),d&2&&(o+="font-weight: bold;");let n="";return d&4&&(n+=" underline"),d&8&&(n+=" line-through"),n&&(o+=`text-decoration:${n};`),o}static getPresentationFromMetadata(a){const h=this.getForeground(a),c=this.getFontStyle(a);return{foreground:h,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$Rs=l}),define(B[25],K([0,1,26]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,l){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=l}replace(r,l,t){if(r>=this.a.length)return;if(l===0){this.insert(r,t);return}else if(t===0){this.delete(r,l);return}const a=this.a.slice(0,r),h=this.a.slice(r+l),c=v(t,this.b);this.a=a.concat(c,h)}delete(r,l){l===0||r>=this.a.length||this.a.splice(r,l)}insert(r,l){if(l===0||r>=this.a.length)return;const t=[];for(let a=0;a<l;a++)t[a]=this.b;this.a=(0,A.$Pf)(this.a,r,t)}}e.$tC=S;function v(T,r){const l=[];for(let t=0;t<T;t++)l[t]=r;return l}}),define(B[7],K([0,1,14]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,l){const t=S.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new S(a,r,l)}constructor(r,l,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=l,this.d=t}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,l,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=l<<1,h=a+(t<<1);for(let c=a;c<h;c++)if(this.a[c]!==r.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const l=this.a[(r<<1)+1],t=A.$Rs.getLanguageId(l);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const l=this.a[(r<<1)+1];return A.$Rs.getTokenType(l)}getForeground(r){const l=this.a[(r<<1)+1];return A.$Rs.getForeground(l)}getClassName(r){const l=this.a[(r<<1)+1];return A.$Rs.getClassNameFromMetadata(l)}getInlineStyle(r,l){const t=this.a[(r<<1)+1];return A.$Rs.getInlineStyleFromMetadata(t,l)}getPresentation(r){const l=this.a[(r<<1)+1];return A.$Rs.getPresentationFromMetadata(l)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,l,t){return new v(this,r,l,t)}static convertToEndOffset(r,l){const a=(r.length>>>1)-1;for(let h=0;h<a;h++)r[h<<1]=r[h+1<<1];r[a<<1]=l}static findIndexInTokensArray(r,l){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const h=t+Math.floor((a-t)/2),c=r[h<<1];if(c===l)return h+1;c<l?t=h+1:c>l&&(a=h)}return t}withInserted(r){if(r.length===0)return this;let l=0,t=0,a="";const h=new Array;let c=0;for(;;){const d=l<this.b?this.a[l<<1]:-1,o=t<r.length?r[t]:null;if(d!==-1&&(o===null||d<=o.offset)){a+=this.c.substring(c,d);const n=this.a[(l<<1)+1];h.push(a.length,n),l++,c=d}else if(o){if(o.offset>c){a+=this.c.substring(c,o.offset);const n=this.a[(l<<1)+1];h.push(a.length,n),c=o.offset}a+=o.text,h.push(a.length,o.tokenMetadata),t++}else break}return new S(new Uint32Array(h),a,this.d)}}e.$Us=S;class v{constructor(r,l,t,a){this.a=r,this.b=l,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(l),this.f=0;for(let h=this.e,c=r.getCount();h<c&&!(r.getStartOffset(h)>=t);h++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const l=this.a.getEndOffset(this.e+r);return Math.min(this.c,l)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,l){return this.a.getInlineStyle(this.e+r,l)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(B[27],K([0,1,7]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=void 0,e.$Vs=new Uint32Array(0).buffer;class S{static deleteBeginning(r,l){return r===null||r===e.$Vs?r:S.delete(r,0,l)}static deleteEnding(r,l){if(r===null||r===e.$Vs)return r;const t=v(r),a=t[t.length-2];return S.delete(r,l,a)}static delete(r,l,t){if(r===null||r===e.$Vs||l===t)return r;const a=v(r),h=a.length>>>1;if(l===0&&a[a.length-2]===t)return e.$Vs;const c=A.$Us.findIndexInTokensArray(a,l),d=c>0?a[c-1<<1]:0,o=a[c<<1];if(t<o){const w=t-l;for(let N=c;N<h;N++)a[N<<1]-=w;return r}let n,i;d!==l?(a[c<<1]=l,n=c+1<<1,i=l):(n=c<<1,i=d);const s=t-l;for(let w=c+1;w<h;w++){const N=a[w<<1]-s;N>i&&(a[n++]=N,a[n++]=a[(w<<1)+1],i=N)}if(n===a.length)return r;const f=new Uint32Array(n);return f.set(a.subarray(0,n),0),f.buffer}static append(r,l){if(l===e.$Vs)return r;if(r===e.$Vs)return l;if(r===null)return r;if(l===null)return null;const t=v(r),a=v(l),h=a.length>>>1,c=new Uint32Array(t.length+a.length);c.set(t,0);let d=t.length;const o=t[t.length-2];for(let n=0;n<h;n++)c[d++]=a[n<<1]+o,c[d++]=a[(n<<1)+1];return c.buffer}static insert(r,l,t){if(r===null||r===e.$Vs)return r;const a=v(r),h=a.length>>>1;let c=A.$Us.findIndexInTokensArray(a,l);c>0&&a[c-1<<1]===l&&c--;for(let d=c;d<h;d++)a[d<<1]+=t;return r}}e.$Ws=S;function v(T){return T instanceof Uint32Array?T:new Uint32Array(T)}e.$Xs=v}),define(B[28],K([0,1,26,12,44,13,27,15]),function(F,e,A,S,v,T,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class t{static deserialize(h,c,d){const o=new Uint32Array(h.buffer),n=(0,S.$Lc)(h,c);c+=4;const i=(0,S.$Lc)(h,c);c+=4;const s=[];for(let f=0;f<i;f++){const w=(0,S.$Lc)(h,c);c+=4,s.push(o.subarray(c/4,c/4+w/4)),c+=w}return d.push(new t(n,s)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,c){this.a=h,this.b=c}getLineRange(){return new l.$qs(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let c=0;c<this.b.length;c++){const d=this.b[c];if(!(d instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=d.byteLength}return h}serialize(h,c){(0,S.$Mc)(h,this.a,c),c+=4,(0,S.$Mc)(h,this.b.length,c),c+=4;for(let d=0;d<this.b.length;d++){const o=this.b[d];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,S.$Mc)(h,o.byteLength,c),c+=4,h.set(new Uint8Array(o.buffer),c),c+=o.byteLength}return c}applyEdit(h,c){const[d,o]=(0,T.$Ts)(c);this.c(h),this.d(new v.$gs(h.startLineNumber,h.startColumn),d,o)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const c=h.startLineNumber-this.a,d=h.endLineNumber-this.a;if(d<0){const o=d-c;this.a-=o;return}if(!(c>=this.b.length)){if(c<0&&d>=this.b.length){this.a=0,this.b=[];return}if(c===d){this.b[c]=r.$Ws.delete(this.b[c],h.startColumn-1,h.endColumn-1);return}if(c>=0)if(this.b[c]=r.$Ws.deleteEnding(this.b[c],h.startColumn-1),d<this.b.length){const o=r.$Ws.deleteBeginning(this.b[d],h.endColumn-1);this.b[c]=r.$Ws.append(this.b[c],o),this.b.splice(c+1,d-c)}else this.b[c]=r.$Ws.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const o=-c;this.a-=o,this.b[d]=r.$Ws.deleteBeginning(this.b[d],h.endColumn-1),this.b=this.b.slice(d)}}}d(h,c,d){if(c===0&&d===0)return;const o=h.lineNumber-this.a;if(o<0){this.a+=c;return}if(!(o>=this.b.length)){if(c===0){this.b[o]=r.$Ws.insert(this.b[o],h.column-1,d);return}this.b[o]=r.$Ws.deleteEnding(this.b[o],h.column-1),this.b[o]=r.$Ws.insert(this.b[o],h.column-1,d),this.e(h.lineNumber,c)}}e(h,c){if(c===0)return;const d=[];for(let o=0;o<c;o++)d[o]=null;this.b=A.$Pf(this.b,h,d)}}e.$Ys=t}),define(B[16],K([0,1,12,28]),function(F,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=void 0;class v{static deserialize(r){let l=0;const t=(0,A.$Lc)(r,l);l+=4;const a=[];for(let h=0;h<t;h++)l=S.$Ys.deserialize(r,l,a);return a}constructor(){this.a=[]}add(r,l){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(l);return}}this.a.push(new S.$Ys(r,[l]))}finalize(){return this.a}serialize(){const r=this.b(),l=new Uint8Array(r);return this.c(l),l}b(){let r=0;r+=4;for(let l=0;l<this.a.length;l++)r+=this.a[l].serializeSize();return r}c(r){let l=0;(0,A.$Mc)(r,this.a.length,l),l+=4;for(let t=0;t<this.a.length;t++)l=this.a[t].serialize(r,l)}}e.$uC=v}),define(B[29],K([0,1,30,3,31,45]),function(F,e,A,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function r(b){return b===47||b===92}e.$De=r;function l(b){return b.replace(/[\\/]/g,A.$8c.sep)}e.$Ee=l;function t(b){return b.indexOf("/")===-1&&(b=l(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.$Fe=t;function a(b,C=A.$8c.sep){if(!b)return"";const j=b.length,z=b.charCodeAt(0);if(r(z)){if(r(b.charCodeAt(1))&&!r(b.charCodeAt(2))){let $=3;const U=$;for(;$<j&&!r(b.charCodeAt($));$++);if(U!==$&&!r(b.charCodeAt($+1))){for($+=1;$<j;$++)if(r(b.charCodeAt($)))return b.slice(0,$+1).replace(/[\\/]/g,C)}}return C}else if(f(z)&&b.charCodeAt(1)===58)return r(b.charCodeAt(2))?b.slice(0,2)+C:b.slice(0,2);let I=b.indexOf("://");if(I!==-1){for(I+=3;I<j;I++)if(r(b.charCodeAt(I)))return b.slice(0,I+1)}return""}e.$Ge=a;function h(b){if(!S.$i||!b||b.length<5)return!1;let C=b.charCodeAt(0);if(C!==92||(C=b.charCodeAt(1),C!==92))return!1;let j=2;const z=j;for(;j<b.length&&(C=b.charCodeAt(j),C!==92);j++);return!(z===j||(C=b.charCodeAt(j+1),isNaN(C)||C===92))}e.$He=h;const c=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,C=S.$i){const j=C?c:d;return!(!b||b.length===0||/^\s+$/.test(b)||(j.lastIndex=0,j.test(b))||C&&o.test(b)||b==="."||b===".."||C&&b[b.length-1]==="."||C&&b.length!==b.trim().length||b.length>255)}e.$Ie=n;function i(b,C,j){const z=b===C;return!j||z?z:!b||!C?!1:(0,v.$Od)(b,C)}e.$Je=i;function s(b,C,j,z=A.sep){if(b===C)return!0;if(!b||!C||C.length>b.length)return!1;if(j){if(!(0,v.$Pd)(b,C))return!1;if(C.length===b.length)return!0;let $=C.length;return C.charAt(C.length-1)===z&&$--,b.charAt($)===z}return C.charAt(C.length-1)!==z&&(C+=z),b.indexOf(C)===0}e.$Ke=s;function f(b){return b>=65&&b<=90||b>=97&&b<=122}e.$Le=f;function w(b,C){return S.$i&&b.endsWith(":")&&(b+=A.sep),(0,A.$0c)(b)||(b=(0,A.$$c)(C,b)),b=(0,A.$9c)(b),S.$i?(b=(0,v.$xd)(b,A.sep),b.endsWith(":")&&(b+=A.sep)):(b=(0,v.$xd)(b,A.sep),b||(b=A.sep)),b}e.$Me=w;function N(b){const C=(0,A.$9c)(b);return S.$i?b.length>3?!1:P(C)&&(b.length===2||C.charCodeAt(2)===92):C===A.$8c.sep}e.$Ne=N;function P(b,C=S.$i){return C?f(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.$Oe=P;function k(b,C=S.$i){return P(b,C)?b[0]:void 0}e.$Pe=k;function g(b,C,j){return C.length>b.length?-1:b===C?0:(j&&(b=b.toLowerCase(),C=C.toLowerCase()),b.indexOf(C))}e.$Qe=g;function y(b){const C=b.split(":");let j,z,I;for(const $ of C){const U=Number($);(0,T.$pe)(U)?z===void 0?z=U:I===void 0&&(I=U):j=j?[j,$].join(":"):$}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:z!==void 0?z:void 0,column:I!==void 0?I:z!==void 0?1:void 0}}e.$Re=y;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(b,C,j=8){let z="";for(let $=0;$<j;$++){let U;$===0&&S.$i&&!C&&(j===3||j===4)?U=O:U=m,z+=U.charAt(Math.floor(Math.random()*U.length))}let I;return C?I=`${C}-${z}`:I=z,b?(0,A.$$c)(b,I):I}e.$Se=D}),define(B[17],K([0,1,6,3,8]),function(F,e,A,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var T;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$We="vscode-tkn",e.$Xe="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${T.vscodeRemoteResource}`}set(h,c,d){this.a[h]=c,this.b[h]=d}setConnectionToken(h,c){this.c[h]=c}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(s){return A.$Y(s),h}const c=h.authority;let d=this.a[c];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const o=this.b[c],n=this.c[c];let i=`path=${encodeURIComponent(h.path)}`;return typeof n=="string"&&(i+=`&${e.$Xe}=${encodeURIComponent(n)}`),v.URI.from({scheme:S.$o?this.d:T.vscodeRemoteResource,authority:`${d}:${o}`,path:this.f,query:i})}}e.$Ye=new r,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(h){const c=this.b(h,F);return this.uriToBrowserUri(c)}uriToBrowserUri(h){return h.scheme===T.vscodeRemote?e.$Ye.rewrite(h):h.scheme===T.file&&(S.$m||S.$p&&S.$g.origin===`${T.vscodeFileResource}://${l.a}`)?h.with({scheme:T.vscodeFileResource,authority:h.authority||l.a,query:null,fragment:null}):h}asFileUri(h){const c=this.b(h,F);return this.uriToFileUri(c)}uriToFileUri(h){return h.scheme===T.vscodeFileResource?h.with({scheme:T.file,authority:h.authority!==l.a?h.authority:null,query:null,fragment:null}):h}b(h,c){return v.URI.isUri(h)?h:v.URI.parse(c.toUrl(h))}}e.$4e=new l;var t;(function(a){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(h.get("3"));const c="vscode-coi";function d(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(c);if(s)return h.get(s)}a.getHeadersFromQuery=d;function o(n,i,s){if(!globalThis.crossOriginIsolated)return;const f=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(c,f):n[c]=f}a.addSearchParam=o})(t||(e.COI=t={}))}),define(B[32],K([0,1,21,17,3,8]),function(F,e,A,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=void 0;class r{constructor(d,o,n){this.id=d,this.dependencies=o,this.callback=n}}class l{static{this.INSTANCE=new l}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,o,n)=>{typeof d!="string"&&(n=o,o=d,d=null),(typeof o!="object"||!Array.isArray(o))&&(n=o,o=null),this.c.push(new r(d,o,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const o=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!o)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}h(d){return new Promise((o,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",f),i.removeEventListener("error",w)},f=N=>{s(),o(this.c.pop())},w=N=>{s(),n(N)};i.addEventListener("load",f),i.addEventListener("error",w),this.f&&(d=this.f.createScriptURL(d)),i.setAttribute("src",d),document.getElementsByTagName("head")[0].appendChild(i)})}i(d){return new Promise((o,n)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),o(this.c.pop())}catch(i){n(i)}})}async j(d){try{const o=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=T.URI.parse(d).fsPath,f=o.readFileSync(s).toString(),w=i.wrap(f.replace(/^#!.*/,""));return new n.Script(w).runInThisContext().apply(),this.c.pop()}catch(o){throw o}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(c,d,o){if(A.$R){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const n=`${c}/${d}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const N=`${o&&!v.$o?S.$2e:S.$1e}/${n}`;i=S.$4e.asBrowserUri(N).toString(!0)}const s=l.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{F([c],n,i)})}e.$9C=h}),define(B[18],K([0,1,29,17,30,3,31,8]),function(F,e,A,S,v,T,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.DataUri=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=void 0;function t(o){return(0,l.$Ve)(o,!0)}e.$7f=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Hd)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===S.Schemas.file)return A.$Ke(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$lg)(n.authority,i.authority))return A.$Ke(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return l.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$dg)(n)||n.authority}basename(n){return v.$8c.basename(n.path)}extname(n){return v.$8c.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===S.Schemas.file?i=l.URI.file(v.$bd(t(n))).path:(i=v.$8c.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===S.Schemas.file?i=l.URI.file(v.$9c(t(n))).path:i=v.$8c.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$lg)(n.authority,i.authority))return;if(n.scheme===S.Schemas.file){const w=v.$ad(t(n),t(i));return T.$i?A.$Ee(w):w}let s=n.path||"/";const f=i.path||"/";if(this.a(n)){let w=0;for(const N=Math.min(s.length,f.length);w<N&&!(s.charCodeAt(w)!==f.charCodeAt(w)&&s.charAt(w).toLowerCase()!==f.charAt(w).toLowerCase());w++);s=f.substr(0,w)+s.substr(w)}return v.$8c.relative(s,f)}resolvePath(n,i){if(n.scheme===S.Schemas.file){const s=l.URI.file(v.$_c(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=A.$Fe(i),n.with({path:v.$8c.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Od)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===S.Schemas.file){const s=t(n);return s.length>A.$Ge(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$mg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===S.Schemas.file){const f=t(n);s=f!==void 0&&f.length===A.$Ge(f).length&&f[f.length-1]===i}else{i="/";const f=n.path;s=f.length===1&&f.charCodeAt(f.length-1)===47}return!s&&!(0,e.$mg)(n,i)?n.with({path:n.path+"/"}):n}}e.$8f=a,e.$9f=new a(()=>!1),e.$0f=new a(o=>o.scheme===S.Schemas.file?!T.$k:!0),e.$$f=new a(o=>!0),e.$_f=e.$9f.isEqual.bind(e.$9f),e.$ag=e.$9f.isEqualOrParent.bind(e.$9f),e.$bg=e.$9f.getComparisonKey.bind(e.$9f),e.$cg=e.$9f.basenameOrAuthority.bind(e.$9f),e.$dg=e.$9f.basename.bind(e.$9f),e.$eg=e.$9f.extname.bind(e.$9f),e.$fg=e.$9f.dirname.bind(e.$9f),e.$gg=e.$9f.joinPath.bind(e.$9f),e.$hg=e.$9f.normalizePath.bind(e.$9f),e.$ig=e.$9f.relativePath.bind(e.$9f),e.$jg=e.$9f.resolvePath.bind(e.$9f),e.$kg=e.$9f.isAbsolutePath.bind(e.$9f),e.$lg=e.$9f.isEqualAuthority.bind(e.$9f),e.$mg=e.$9f.hasTrailingPathSeparator.bind(e.$9f),e.$ng=e.$9f.removeTrailingPathSeparator.bind(e.$9f),e.$og=e.$9f.addTrailingPathSeparator.bind(e.$9f);function h(o,n){const i=[];for(let s=0;s<o.length;s++){const f=n(o[s]);o.some((w,N)=>N===s?!1:(0,e.$ag)(f,n(w)))||i.push(o[s])}return i}e.$pg=h;var c;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(N=>{const[P,k]=N.split(":");P&&k&&s.set(P,k)});const w=i.path.substring(0,i.path.indexOf(";"));return w&&s.set(o.META_DATA_MIME,w),s}o.parseMetaData=n})(c||(e.DataUri=c={}));function d(o,n,i){if(n){let s=o.path;return s&&s[0]!==v.$8c.sep&&(s=v.$8c.sep+s),o.with({scheme:i,authority:n,path:s})}return o.with({scheme:i})}e.$qg=d}),define(B[19],K([0,1,46,6,33,2,18,3,24]),function(F,e,A,S,v,T,r,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.$2g=e.$1g=e.Promises=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function a(M){return!!M&&typeof M.then=="function"}e.$rg=a;function h(M){const u=new A.$rc,E=M(u.token),L=new Promise((R,q)=>{const Y=u.token.onCancellationRequested(()=>{Y.dispose(),u.dispose(),q(new S.$3)});Promise.resolve(E).then(Z=>{Y.dispose(),u.dispose(),R(Z)},Z=>{Y.dispose(),u.dispose(),q(Z)})});return new class{cancel(){u.cancel()}then(R,q){return L.then(R,q)}catch(R){return this.then(void 0,R)}finally(R){return L.finally(R)}}}e.$sg=h;function c(M,u,E){return new Promise((L,R)=>{const q=u.onCancellationRequested(()=>{q.dispose(),L(E)});M.then(L,R).finally(()=>q.dispose())})}e.$tg=c;function d(M,u){return new Promise((E,L)=>{const R=u.onCancellationRequested(()=>{R.dispose(),L(new S.$3)});M.then(E,L).finally(()=>R.dispose())})}e.$ug=d;async function o(M){let u=-1;const E=M.map((L,R)=>L.then(q=>(u=R,q)));try{return await Promise.race(E)}finally{M.forEach((L,R)=>{R!==u&&L.cancel()})}}e.$vg=o;function n(M,u,E){let L;const R=setTimeout(()=>{L?.(void 0),E?.()},u);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(q=>L=q)])}e.$wg=n;function i(M){return new Promise((u,E)=>{const L=M();a(L)?L.then(u,E):u(L)})}e.$xg=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=u,!this.b){const E=()=>{if(this.b=null,this.f)return;const L=this.queue(this.d);return this.d=null,L};this.b=new Promise(L=>{this.a.then(E,E).then(L)})}return new Promise((E,L)=>{this.b.then(E,L)})}return this.a=u(),new Promise((E,L)=>{this.a.then(R=>{this.a=null,E(R)},R=>{this.a=null,L(R)})})}dispose(){this.f=!0}}e.$yg=s;class f{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$zg=f;class w{constructor(){this.a=new Map}queue(u,E){const R=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(u)===R&&this.a.delete(u)});return this.a.set(u,R),R}}e.$Ag=w;const N=(M,u)=>{let E=!0;const L=setTimeout(()=>{E=!1,u()},M);return{isTriggered:()=>E,dispose:()=>{clearTimeout(L),E=!1}}},P=M=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,M())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class k{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,E=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((R,q)=>{this.d=R,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const L=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$ec?P(L):N(E,L),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bg=k;class g{constructor(u){this.a=new k(u),this.b=new s}trigger(u,E){return this.a.trigger(()=>this.b.queue(u),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Cg=g;class y{constructor(){this.a=!1,this.b=new Promise((u,E)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dg=y;class m extends y{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$Eg=m;function O(M,u){return u?new Promise((E,L)=>{const R=setTimeout(()=>{q.dispose(),E()},M),q=u.onCancellationRequested(()=>{clearTimeout(R),q.dispose(),L(new S.$3)})}):h(E=>O(M,E))}e.$Fg=O;function D(M,u=0){const E=setTimeout(M,u);return(0,T.$kb)(()=>clearTimeout(E))}e.$Gg=D;function b(M){const u=[];let E=0;const L=M.length;function R(){return E<L?M[E++]():null}function q(Y){Y!=null&&u.push(Y);const Z=R();return Z?Z.then(q):Promise.resolve(u)}return Promise.resolve(null).then(q)}e.$Hg=b;function C(M,u=L=>!!L,E=null){let L=0;const R=M.length,q=()=>{if(L>=R)return Promise.resolve(E);const Y=M[L++];return Promise.resolve(Y()).then(J=>u(J)?Promise.resolve(J):q())};return q()}e.$Ig=C;function j(M,u=L=>!!L,E=null){if(M.length===0)return Promise.resolve(E);let L=M.length;const R=()=>{L=-1;for(const q of M)q.cancel?.()};return new Promise((q,Y)=>{for(const Z of M)Z.then(J=>{--L>=0&&u(J)?(R(),q(J)):L===0&&q(E)}).catch(J=>{--L>=0&&(R(),Y(J))})})}e.$Jg=j;class z{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new v.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((E,L)=>{this.f.push({factory:u,c:E,e:L}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const E=u.factory();E.then(u.c,u.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Kg=z;class I extends z{constructor(){super(1)}}e.$Lg=I;class ${constructor(){this.a=new x,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$Mg=$;class U{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const u=new te;return this.b.add(u),u.p}d(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,E=r.$9f){const L=E.getComparisonKey(u);let R=this.a.get(L);return R||(R=new I,v.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(L),this.f()}),this.a.set(L,R)),R}f(){this.d()&&this.g()}g(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.g()}}e.$Ng=U;class V{constructor(u,E){this.a=-1,typeof u=="function"&&typeof E=="number"&&this.setIfNotSet(u,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},E)}setIfNotSet(u,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},E))}}e.$Og=V;class G{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(u,E){this.cancel(),this.a=setInterval(()=>{u()},E)}}e.$Pg=G;class _{constructor(u,E){this.b=-1,this.a=u,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qg=_;class H{constructor(u,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=u,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rg=H;class W extends _{constructor(u,E){super(u,E),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$Sg=W;class p extends T.$mb{constructor(u,E){super(),this.g=u,this.h=E,this.a=[],this.b=this.B(new T.$nb),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of u)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Tg=p,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ug=M=>{(0,l.$A)(()=>{if(u)return;const E=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:e.$Ug=(M,u)=>{const E=requestIdleCallback(M,typeof u=="number"?{timeout:u}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(E))}}}}();class Q{constructor(u){this.d=!1,this.a=()=>{try{this.f=u()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Vg=Q;async function re(M,u,E){let L;for(let R=0;R<E;R++)try{return await M()}catch(q){L=q,await O(u)}throw L}e.$Wg=re;class x{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,E,L){return this.a={taskId:u,cancel:()=>L?.(),promise:E},E.then(()=>this.d(u),()=>this.d(u)),E}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let E,L;const R=new Promise((q,Y)=>{E=q,L=Y});this.b={run:u,promise:R,promiseResolve:E,promiseReject:L}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xg=x;class ae{constructor(u,E=()=>Date.now()){this.d=u,this.f=E,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$Yg=ae;var ee;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,E)=>{this.a=u,this.b=E})}complete(u){return new Promise(E=>{this.a(u),this.d={outcome:0,value:u},E()})}error(u){return new Promise(E=>{this.b(u),this.d={outcome:1,value:u},E()})}cancel(){return this.error(new S.$3)}}e.$Zg=te;var ne;(function(M){async function u(L){let R;const q=await Promise.all(L.map(Y=>Y.then(Z=>Z,Z=>{R||(R=Z)})));if(typeof R<"u")throw R;return q}M.settled=u;function E(L){return new Promise(async(R,q)=>{try{await L(R,q)}catch(Y){q(Y)}})}M.withAsyncBody=E})(ne||(e.Promises=ne={}));var ie;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(ie||(ie={}));class X{static fromArray(u){return new X(E=>{E.emitMany(u)})}static fromPromise(u){return new X(async E=>{E.emitMany(await u)})}static fromPromises(u){return new X(async E=>{await Promise.all(u.map(async L=>E.emitOne(await L)))})}static merge(u){return new X(async E=>{await Promise.all(u.map(async L=>{for await(const R of L)E.emitOne(R)}))})}static{this.EMPTY=X.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new v.$hc,queueMicrotask(async()=>{const E={emitOne:L=>this.g(L),emitMany:L=>this.h(L),reject:L=>this.k(L)};try{await Promise.resolve(u(E)),this.j()}catch(L){this.k(L)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(u,E){return new X(async L=>{for await(const R of u)L.emitOne(E(R))})}map(u){return X.map(this,u)}static filter(u,E){return new X(async L=>{for await(const R of u)E(R)&&L.emitOne(R)})}filter(u){return X.filter(this,u)}static coalesce(u){return X.filter(u,E=>!!E)}coalesce(){return X.coalesce(this)}static async toPromise(u){const E=[];for await(const L of u)E.push(L);return E}toPromise(){return X.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$1g=X;class se extends X{constructor(u,E){super(E),this.l=u}cancel(){this.l.cancel()}}e.$2g=se;function ce(M){const u=new A.$rc,E=M(u.token);return new se(u,async L=>{const R=u.token.onCancellationRequested(()=>{R.dispose(),u.dispose(),L.reject(new S.$3)});try{for await(const q of E){if(u.token.isCancellationRequested)return;L.emitOne(q)}R.dispose(),u.dispose()}catch(q){R.dispose(),u.dispose(),L.reject(q)}})}e.$3g=ce}),define(B[20],K([0,1,34]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sC=e.$rC=e.$qC=void 0,e.$qC=new class{clone(){return this}equals(T){return this===T}};function S(T,r){return new A.$2s([new A.$1s(0,"",T)],r)}e.$rC=S;function v(T,r){const l=new Uint32Array(2);return l[0]=0,l[1]=(T<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new A.$3s(l,r===null?e.$qC:r)}e.$sC=v}),define(B[35],K([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(F,e,A,S,v,T,r,l,t,a,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=e.$zC=e.$yC=e.$xC=e.$wC=e.$vC=void 0;var o;(function(k){k[k.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(o||(o={}));class n{constructor(g,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(g)}getStartState(g){return this.store.getStartState(g,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$vC=n;class i extends n{constructor(g,y,m,O){super(g,y),this._textModel=m,this._languageIdCodec=O}updateTokensUntilLine(g,y){const m=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>y)break;const D=this._textModel.getLineContent(O.lineNumber),b=N(this._languageIdCodec,m,this.tokenizationSupport,D,!0,O.startState);g.add(O.lineNumber,b.tokens),this.store.setEndState(O.lineNumber,b.endState)}}getTokenTypeIfInsertingCharacter(g,y){const m=this.getStartState(g.lineNumber);if(!m)return 0;const O=this._textModel.getLanguageId(),D=this._textModel.getLineContent(g.lineNumber),b=D.substring(0,g.column-1)+y+D.substring(g.column-1),C=N(this._languageIdCodec,O,this.tokenizationSupport,b,!0,m),j=new d.$Us(C.tokens,b,this._languageIdCodec);if(j.getCount()===0)return 0;const z=j.findTokenIndexAtOffset(g.column-1);return j.getStandardTokenType(z)}tokenizeLineWithEdit(g,y,m){const O=g.lineNumber,D=g.column,b=this.getStartState(O);if(!b)return null;const C=this._textModel.getLineContent(O),j=C.substring(0,D-1)+m+C.substring(D-1+y),z=this._textModel.getLanguageIdAtPosition(O,0),I=N(this._languageIdCodec,z,this.tokenizationSupport,j,!0,b);return new d.$Us(I.tokens,j,this._languageIdCodec)}isCheapToTokenize(g){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<y||g===y&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,y,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,m),{heuristicTokens:!1};let O=this.b(y);const D=this._textModel.getLanguageId();for(let b=y;b<=m;b++){const C=this._textModel.getLineContent(b),j=N(this._languageIdCodec,D,this.tokenizationSupport,C,!0,O);g.add(b,j.tokens),O=j.endState}return{heuristicTokens:!0}}b(g){let y=this._textModel.getLineFirstNonWhitespaceColumn(g);const m=[];let O=null;for(let C=g-1;y>1&&C>=1;C--){const j=this._textModel.getLineFirstNonWhitespaceColumn(C);if(j!==0&&j<y&&(m.push(this._textModel.getLineContent(C)),y=j,O=this.getStartState(C),O))break}O||(O=this.tokenizationSupport.getInitialState()),m.reverse();const D=this._textModel.getLanguageId();let b=O;for(const C of m)b=N(this._languageIdCodec,D,this.tokenizationSupport,C,!1,b).endState;return b}}e.$wC=i;class s{constructor(g){this.d=g,this.a=new f,this.b=new w,this.b.addRange(new t.$os(1,g+1))}getEndState(g){return this.a.getEndState(g)}setEndState(g,y){if(!y)throw new S.$ab("Cannot set null/undefined state");this.b.delete(g);const m=this.a.setEndState(g,y);return m&&g<this.d&&this.b.addRange(new t.$os(g+1,g+2)),m}acceptChange(g,y){this.d+=y-g.length,this.a.acceptChange(g,y),this.b.addRangeAndResize(new t.$os(g.startLineNumber,g.endLineNumberExclusive),y)}acceptChanges(g){for(const y of g){const[m]=(0,r.$Ts)(y.text);this.acceptChange(new l.$qs(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}invalidateEndStateRange(g){this.b.addRange(new t.$os(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(g,y){return g===1?y:this.getEndState(g-1)}getFirstInvalidLine(g){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const m=this.getStartState(y,g);if(!m)throw new S.$ab("Start state must be defined");return{lineNumber:y,startState:m}}}e.$xC=s;class f{constructor(){this.a=new h.$tC(null)}getEndState(g){return this.a.get(g)}setEndState(g,y){const m=this.a.get(g);return m&&m.equals(y)?!1:(this.a.set(g,y),!0)}acceptChange(g,y){let m=g.length;y>0&&m>0&&(m--,y--),this.a.replace(g.startLineNumber,m,y)}acceptChanges(g){for(const y of g){const[m]=(0,r.$Ts)(y.text);this.acceptChange(new l.$qs(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}}e.$yC=f;class w{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const g=this.a[0];return g.start+1===g.endExclusive?this.a.shift():this.a[0]=new t.$os(g.start+1,g.endExclusive),g.start}delete(g){const y=this.a.findIndex(m=>m.contains(g));if(y!==-1){const m=this.a[y];m.start===g?m.endExclusive===g+1?this.a.splice(y,1):this.a[y]=new t.$os(g+1,m.endExclusive):m.endExclusive===g+1?this.a[y]=new t.$os(m.start,g):this.a.splice(y,1,new t.$os(m.start,g),new t.$os(g+1,m.endExclusive))}}addRange(g){t.$os.addRange(g,this.a)}addRangeAndResize(g,y){let m=0;for(;!(m>=this.a.length||g.start<=this.a[m].endExclusive);)m++;let O=m;for(;!(O>=this.a.length||g.endExclusive<this.a[O].start);)O++;const D=y-g.length;for(let b=O;b<this.a.length;b++)this.a[b]=this.a[b].delta(D);if(m===O){const b=new t.$os(g.start,g.start+y);b.isEmpty||this.a.splice(m,0,b)}else{const b=Math.min(g.start,this.a[m].start),C=Math.max(g.endExclusive,this.a[O-1].endExclusive),j=new t.$os(b,C+D);j.isEmpty?this.a.splice(m,O-m):this.a.splice(m,O-m,j)}}toString(){return this.a.map(g=>g.toString()).join(" + ")}}e.$zC=w;function N(k,g,y,m,O,D){let b=null;if(y)try{b=y.tokenizeEncoded(m,O,D.clone())}catch(C){(0,S.$Y)(C)}return b||(b=(0,a.$sC)(k.encodeLanguageId(g),D)),d.$Us.convertToEndOffset(b.tokens,m.length),b}class P{constructor(g,y){this.b=g,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,A.$Ug)(g=>{this.f=!1,this.h(g)}))}h(g){const y=Date.now()+g.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$A)(m):this.g())};m()}j(){const g=this.b._textModel.getLineCount(),y=new c.$uC,m=T.$dc.create(!1);do if(m.elapsed()>1||this.l(y)>=g)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(g){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(g,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(g,y){this.b.store.invalidateEndStateRange(new l.$qs(g,y))}}e.$AC=P}),define(B[37],K([0,1,33,2,36,14,34]),function(F,e,A,S,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XAb=void 0;class l extends S.$mb{constructor(a,h,c,d,o,n,i){super(),this.c=a,this.f=h,this.g=c,this.h=d,this.j=o,this.k=n,this.l=i,this.a=[],this.b=this.B(new A.$hc),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,h,c){throw new Error("Not supported!")}createBackgroundTokenizer(a,h){if(this.h)return this.h(a,h)}tokenizeEncoded(a,h,c){const d=Math.random()*1e4<1,o=this.l||d,n=o?new v.$dc(!0):void 0,i=this.c.tokenizeLine2(a,c,500);if(o){const f=n.elapsed();(d||f>32)&&this.k(f,a.length,d)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$3s(i.tokens,c);if(this.g){const f=this.a,w=i.tokens;for(let N=0,P=w.length>>>1;N<P;N++){const k=w[(N<<1)+1],g=T.$Rs.getLanguageId(k);f[g]||(f[g]=!0,this.b.fire(g))}}let s;return c.equals(i.ruleStack)?s=c:s=i.ruleStack,new r.$3s(i.tokens,s)}}e.$XAb=l}),define(B[38],K([0,1,20,2,11]),function(F,e,A,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YAb=void 0;class T extends S.$mb{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(l,t,a){super(),this.a=l,this.b=t,this.c=a,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(l,t,a){throw new Error("Not supported!")}tokenizeEncoded(l,t,a){return l.length>=this.c.get()?(0,A.$sC)(this.a,a):this.b.tokenizeEncoded(l,t,a)}createBackgroundTokenizer(l,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(l,t)}}e.$YAb=T}),define(B[39],K([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(F,e,A,S,v,T,r,l,t,a,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Ab=void 0;class o extends l.$Ju{constructor(s,f,w,N,P,k,g,y){super(s,f,w,N),this.s=P,this.t=k,this.u=g,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new S.$Qg(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,f){this.t=s,this.u=f,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,f){this.a&&(this.a.store.invalidateEndStateRange(new r.$qs(s,f)),this.q.schedule())}async v(){this.a=null;const s=this.t,f=this.u,w=await this.s.getOrCreateGrammar(s,f);if(!(this.b||s!==this.t||f!==this.u||!w)){if(w.grammar){const N=new d.$YAb(this.u,new c.$XAb(w.grammar,w.initialState,!1,void 0,()=>!1,(P,k,g)=>{this.s.reportTokenizationTime(P,s,w.sourceExtensionId,k,g)},!1),this.c);this.a=new t.$vC(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:f}=await(0,A.$9C)("vscode-textmate","release/main.js");this.m=f}const s=new Date().getTime();for(;;){let f=0;const w=new a.$uC,N=new n;for(;;){const g=this.a.getFirstInvalidLine();if(g===null||f>200)break;f++;const y=this.f[g.lineNumber-1],m=this.a.tokenizationSupport.tokenizeEncoded(y,!0,g.startState);if(this.a.store.setEndState(g.lineNumber,m.endState)){const D=this.m(g.startState,m.endState);N.setState(g.lineNumber,D)}else N.setState(g.lineNumber,null);if(h.$Us.convertToEndOffset(m.tokens,y.length),w.add(g.lineNumber,m.tokens),new Date().getTime()-s>20)break}if(f===0)break;const P=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,w.serialize(),P),new Date().getTime()-s>20){(0,T.$A)(()=>this.w());return}}}}e.$4Ab=o;class n{constructor(){this.a=-1,this.b=[]}setState(s,f){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(f):this.b.push({startLineNumber:s,stateDeltas:[f]}),this.a=s}getStateDeltas(){return this.b}}}),define(B[40],K([0,1,18]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Ab=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(T){if(this.a[T.scopeName]){const r=this.a[T.scopeName];A.$_f(r.location,T.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${T.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${T.location.toString()}`)}this.a[T.scopeName]=T}getGrammarDefinition(T){return this.a[T]||null}}e.$1Ab=S}),define(B[41],K([0,1,2,40]),function(F,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Ab=e.$2Ab=void 0,e.$2Ab="No TM Grammar registered for this language.";class v extends A.$mb{constructor(r,l,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new S.$1Ab,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async h=>{const c=this.c.getGrammarDefinition(h);if(!c)return this.a.logTrace(`No grammar found for scope ${h}`),null;const d=c.location;try{const o=await this.a.readFile(d);return t.parseRawGrammar(o,d.path)}catch(o){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${d}`,o),null}},getInjections:h=>{const c=h.split(".");let d=[];for(let o=1;o<=c.length;o++){const n=c.slice(0,o).join(".");d=[...d,...this.f[n]||[]]}return d}}));for(const h of l){if(this.c.register(h),h.injectTo){for(const c of h.injectTo){let d=this.f[c];d||(this.f[c]=d=[]),d.push(h.scopeName)}if(h.embeddedLanguages)for(const c of h.injectTo){let d=this.g[c];d||(this.g[c]=d=[]),d.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(r){return this.h.has(r)}setTheme(r,l){this.j.setTheme(r,l)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,l){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$2Ab);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$2Ab);const h=a.embeddedLanguages;if(this.g[t]){const o=this.g[t];for(const n of o)for(const i of Object.keys(n))h[i]=n[i]}const c=Object.keys(h).length>0;let d;try{d=await this.j.loadGrammarWithConfiguration(t,l,{embeddedLanguages:h,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.$2Ab):o}return{languageId:r,grammar:d,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:a.sourceExtensionId}}}e.$3Ab=v}),define(B[49],K([0,1,8,41,39]),function(F,e,A,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function T(l,t){return new r(l,t)}e.create=T;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const h=a.grammarDefinitions.map(c=>({location:A.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(h)}async g(t){const a=this.f.textmateMainUri,h=await new Promise((i,s)=>{F([a],i,s)}),c=await new Promise((i,s)=>{F([this.f.onigurumaMainUri],i,s)}),o=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(o);const n=Promise.resolve({createOnigScanner:i=>c.createOnigScanner(i),createOnigString:i=>c.createOnigString(i)});return new S.$3Ab({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,h,n)}acceptNewModel(t){const a=A.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$4Ab(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,d){const o=await h.d;return o?(h.c[d]||(h.c[d]=o.createGrammar(c,d)),h.c[d]):Promise.resolve(null)},setTokensAndStates(c,d,o){h.a.setTokensAndStates(t.controllerId,c,d,o)},reportTokenizationTime(c,d,o,n,i){h.a.reportTokenizationTime(c,d,o,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,h){this.b.get(t).retokenize(a,h)}acceptModelLanguageChanged(t,a,h){this.b.get(t).onLanguageId(a,h)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/df703092cd69d660608c3979b9db2e00ddb6185e/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
